<%Option Explicit

Sub FormatSearchResults()

  Const cQSSearchText = "DisplayText"
  Const cQSRecordNum = "RecordNum"
  
  Const cCatalogueName       = "digitaltier"	'* The name of the Site Server index to use
  
  Const cRecordsPerPage		 = 10			'* how many records do you want to show per page
  
  Const cUntitledDocText     = "No Title"	'* Text to show for documents that have no varDocTitle 
  Const cTimeoutMsg		     = "Not all matching documents are listed because your query is too complex to complete." 	
  Const cMoreResultsLinkText = "Next &gt;&gt;"
  Const cFormCriteriaName    = "txtCriteria"
  
  
  Dim varSearchText
  Dim varRecordNum				'* Records number
  Dim varTotalRecords
  
  Dim objUtil						'* Utility object to convert locale info
  Dim objQuery						'* The search object
  Dim objRecordSet				'* Search results set
         
  Dim varDocTitle
  Dim varLink
  Dim varLinkTarget
  Dim varFormat		 
  Dim varDocType
  Dim varRank
  Dim varImageURL
    
  Dim varRecordCount
  Dim varSummaryHTML		'* we'll create the top and bottom summary text once
  
    
  '****************************************************************************
  '* J. Hales
  '* This web page provides the action for the form submit.  We'll need to check
  '* URL and Referrer to see if they are the same and then the form criteira 
  '* to see if it's empty
  '* Thsi only applies if they have not set the next page to go to
  '****************************************************************************
  If Right( Request.ServerVariables("http_referer"), Len(Request.ServerVariables("url")) ) = Request.ServerVariables("url") _
     And Request.QueryString(cQSSearchText) = "" Then
    If Trim(Request.Form(cFormCriteriaName)) = "" Then
      Response.Write "<B>Search needs a valid word or phrase to search for. Please try again.</B><BR>" 
      Exit Sub
    End If
  End If
  
  '****************************************************************************
  '* J. Hales
  '* Create the Site Server Search objects
  '* The Util object allows us to handle different languages
  '* The Query object does the actual search and can be called
  '* in a number of different ways
  '* Don't forget that this page calls itself if there is more than
  '* one page of search results
  '****************************************************************************
  Set objUtil = Server.CreateObject(("MSSearch.util") 
  Set objQuery = Server.CreateObject("MSSearch.Query") 
 
  '****************************************************************************
  '* J. Hales
  '* Have they requested the next page of results?  
  '* If they have then the QueryString 'SearchText' will have a value
  '* We can then take the entire QueryString and pass it to Query object using 
  '* the SetQueryFromURL method.
  '****************************************************************************
  If Request.QueryString(cQSSearchText) = "" Then 
    '****************************************************************************
    '* J. Hales
    '* Here it is the first time that this page has been called.  So we need
    '* to check the Request.Form object for the search criteria that was entered
    '* into a form.  This page may have been called by another [quick] sort page.
    '* In this case the text box is called
    '****************************************************************************
    varSearchText = Request.Form(cFormCriteriaName)
    objQuery.Query = varSearchText				'* Tell it the phrase to search for - don't forget you can search searchable columns '" Q.Query = "#DocTitle Windows* and printer near drivers"
  Else
    '****************************************************************************
    '* J. Hales
    '* The SetQueryFromURL method sets the corresponding search criteria properties
    '* based on the specified URL, ie it sets .Query, .SortBy, .MaxRecords
    '* So the QueryString qu=@size>1000&so=rank[d]&mh=100
    '* Is equilant to the following:
    '*    objQuery.Query = "@size > 1000"
    '*    objQuery.SortBy = "rank[d]"
    '*    objQuery.MaxRecords = 100
    '* 
    '* Thus	
    '*	ae - Used by the AllowEnumeration property. If set to a nonzero digit, enumeration is allowed.  
    '*	ct - Used by the Catalog property.  
    '*	di - Used by the Dialect property.  
    '*	gd - GroupBy descending. Used by the GroupBy property.  
    '*	gr - Used by the GroupBy property.  
    '*	mh - Used by the MaxRecords property.  
    '*	qu - Full text of query. Used by the Query property. 
    '*	so - Used by the SortBy property.  
    '*	sd - Sort descending. Used by the SortBy property.  
    '****************************************************************************
    varSearchText = Request.QueryString(cQSSearchText)
    objQuery.SetQueryFromURL Request.QueryString
  End if 

  '****************************************************************************
  '* J. Hales
  '* .Columns is equivilant to a SQL SELECT statement.  It defines the columns
  '* that you want to return back to the ADO recordset.
  '* Site Server uses the file \Microsoft Site Server\Data\Search\Config\DEFINECOLUMNS.TXT
  '* to define friendly names for columns
  '****************************************************************************
  objQuery.Columns = "DocTitle, DocAddress, FileWrite, Size, Description, FileName, DocSignature, Rank, HitCount, DetectedLanguage, MimeType, SiteName, NNTP_MessageID" 
  objQuery.MaxRecords = cRecordsPerPage					    '* The max number of records to fetch per page - not the total!
  objQuery.SortBy = "Rank[d],DocTitle"            '* Sort by rank/match in descending order and then by document varDocTitle

  '****************************************************************************
  '* J. Hales
  '* Now we can tell it the name of the catagloue to use.  If the catalogue is a 
  '* directory crawl then the DocAddress will come back as a physical path
  '* for a web varLink crawl it will come back as a virtual web url
  '****************************************************************************
  objQuery.catalog = cCatalogueName
  
  '****************************************************************************
  '* J. Hales
  '* As this page is used as the action for the search form AND
  '* as the next page dsiplay in the search results we need to exit if
  '* the search text has not yet been specified by the user
  '****************************************************************************
  If varSearchText = "" Then
    Exit Sub
  End If
    
  '****************************************************************************
  '* J. Hales
  '* It's nicer for the user if we show the critera we are searching 
  '* so that they can edit it again if called form another page
  '****************************************************************************
  Response.Write "<SCRIPT>document.frmSearch." & cFormCriteriaName & ".value = '" & varSearchText & "';</SCRIPT>"
	
  '****************************************************************************
  '* J. Hales
  '* For each page of results we need to know which page they are on
  '* in order to calculate the correct record position.
  '* RecordNum gets set for the Next page
  '****************************************************************************
  If Request(cQSRecordNum) = "" Then
    varRecordNum = 1				'* It's the first time called so this is page 1
  Else
    varRecordNum = Request(cQSRecordNum)
  End If 

  '****************************************************************************
  '* J. Hales
  '* We've set up all of the required parameters so we just need to call
  '* the CreateRecordSet function to return a standard ADO RecordSet that we
  '* all know and love
  '* CreateRecordSet has once argument - strCursorType.  This can be either
  '* "sequential" or "nonsequential"  and defines whether you can move backwarda
  '* through the results
  '* You'll need some error handlign aroudn this otherwise you'll get ASP errors
  '* shown for various stages
  '****************************************************************************   
  On Error Resume Next
  Set objRecordSet = objQuery.CreateRecordSet("sequential") 
  If Err Then
    Response.write "<br>No documents matching your query were found.  Please try again with different search criteria."
	Exit Sub
  End If
  
  '* The recordset was created successfully but did it return anything
  If objRecordSet Is Nothing Then
    Response.write "<br>No documents matching your query were found."
    Exit Sub
  End If
  
  '* If no matches were found so display a message.
  If objRecordSet.BOF And objRecordSet.EOF Then
	
	  '* It may have been too complex to understand
      If objQuery.QueryIncomplete = true Then
        Response.write "<br>Your query is too complex.  Please try a simpler query."
      Else
        Response.write "<br>No documents matching your query were found."
      End if
      
      Exit Sub
  End If      
      

  '****************************************************************************
  '* J. Hales
  '* Tell them how many we found and what we are currently showing
  '****************************************************************************
  varSummaryHTML = "<TABLE width=""600"">" & vbNewLine & _
                   "  <TR>" & vbNewLine & _
                   "    <TD valign=""top"" align=""left"">Search results for: <B>" & varSearchText & "</B><BR></TD>" & vbNewLine & _
                   "    <TD valign=""top"" align=""right""><B>" & varRecordNum & " to " 
  If objRecordSet.Properties("RowCount") > (varRecordNum + objQuery.MaxRecords -1) Then
    '* For last page with more than one result.
    varSummaryHTML = varSummaryHTML & varRecordNum + objQuery.MaxRecords - 1
  Else
    varSummaryHTML = varSummaryHTML & objRecordSet.Properties("RowCount") 
  End If
  varSummaryHTML = varSummaryHTML & "</B>"
  
  '****************************************************************************
  '* J. Hales
  '* We must have got some results back so let's process them
  '* First of all check the ADO properties to see if we've gone past the max
  '* num of records to retrieve
  '****************************************************************************
  varTotalRecords = objRecordSet.Properties("RowCount")
  If objRecordSet.Properties("RowLimitExceeded") Then
    varSummaryHTML = varSummaryHTML & " of over " & varTotalRecords
  Else
    varSummaryHTML = varSummaryHTML & " of " & varTotalRecords
  End If
  
  '****************************************************************************
  '* J. Hales
  '* Add the plural for 'records' if applicable
  '****************************************************************************
  If varTotalRecords > 1 Then
	varSummaryHTML = varSummaryHTML & " results"
  End If
  varSummaryHTML = varSummaryHTML & "</TD></TR></TABLE>"
    
  '****************************************************************************
  '* J. Hales
  '* Add the end of the results row and output the top
  '****************************************************************************
  Response.Write varSummaryHTML
  
  '****************************************************************************
  '* J. Hales
  '* Create the table. of results
  '* The first and last rows will contain a summary of what was found 
  '* with the rows in between containing the search results
  '****************************************************************************
  Response.Write "<P><table valign=""top"" width=""100%"" align=""left"" border=""0"" name=""tblResults"">"  

  '****************************************************************************
  '* J. Hales
  '* Go thru and create a table row for each search result
  '* We'll use a Do Loop here because at this stage we will have at least one
  '* record to show
  '****************************************************************************
  Do 

	'****************************************************************************
    '* J. Hales
    '* Based on the document type (MimeType) we'll need to set a flag to indicate
    '* if it's a document or newsgroup message - mind you how many are going
    '* to be newsgroup items on a standard web site?
    '****************************************************************************
    varFormat = objRecordSet("MimeType") 
    Select Case varFormat
	  Case "text/html", "application/x-msexcel", "application/msword", "application/x-mspowerpoint"  
	    '* HTML and MS applications can be defined as Doc
	    varDocType = "doc"
			
	  Case Else	
	    '* If it's a newsgroup then it will have a message ID
		If InStr(varFormat, "text/plain") > 0 or InStr(varFormat, "richtext") > 0  then 
			varDocType = "doc"
		ElseIf objRecordSet("NNTP_MessageID") <> "" Then
			varDocType = "newsgroup"
		Else
			varDocType = "undefined"
		End If 
	End Select		
		
	'****************************************************************************
    '* J. Hales
    '* Build up the item details to show
    '*   varDocTitle:	If it's empty then put the default empty msg
    '*					If it's a newsgroup then put 'no subject'
    '*   varLink:		The URL to link to - prefixed with news:// for newsgroups
    '*   varLinkTarget:	Use a new window for newsgroup
    '****************************************************************************		
	If objRecordSet("DocTitle") <> "" Then   
	  varDocTitle = objRecordSet("DocTitle")
	ElseIf varDocType="newsgroup" then
	  varDocTitle = "No subject"
	ElseIf objRecordSet("FileName") <> "" then
	  varDocTitle = cUntitledDocText & ": " & objRecordSet("FileName") 
	Else
	  varDocTitle = cUntitledDocText & ": " & objRecordSet("DocAddress") 
	End If
 
	If varDocType = "newsgroup" Then
	    varLink = "news://" & objRecordSet("SiteName") & "/" & objRecordSet("NNTP_MessageID")
		varLinkTarget = ""
	Else
	    varLink = objRecordSet("DocAddress")
		varLinkTarget = "target=""new"""
    End If
     
	'****************************************************************************
    '* J. Hales
    '* The rank is a number form 0 to 1000 with 1000 being the best match
    '* For each multiple of 200 we'll display a nice star
    '****************************************************************************
	varRank = objRecordSet("Rank")
	If IsNull(varRank) Then
		varRank = 0
		varImageURL = "1"
	Else	
		If varRank < 200 Then
			varImageURL = "1"
		Else	
			varImageURL = CStr(varRank \ 200)
		End If
	End If
	
    '****************************************************************************
    '* J. Hales
    '* Now that we've populated all fot he vairables we can create 
    '* the table row search result
    '* Each item will appear in the followign format
    '*		RecordNum (based on the current page)
    '*		Ranking using star graphics
    '*		commented Rank Value
    '*		<A URL>DocumentTitle</A>
    '*		Truncate contents to first 200 letters
    '*		URL"
    '****************************************************************************
   	Response.Write "<TR>" & vbNewLine & _
   	               "  <TD valign=""top""><B>" & varRecordNum & ".</B></TD>" & vbNewLine & _
   	               "  <TD valign=""top""><IMG SRC=""images/star" & varImageURL & ".gif"" ALT=""" & String(cint(varImageURL), "*")  & """>"  & vbNewLine & _
   	               "                     <!-- Rank=" & varRank & "--></TD>"  & vbNewLine & _
   	               "  <TD valign=""top""><A " & varLinkTarget & " HREF=""" & varLink & """><B>" & varDocTitle & "</B></A><BR>" & vbNewLine & _
   	               "                     " & objUtil.TruncateToWhiteSpace(objRecordSet("Description"), 250) & "<BR>" & vbNewLine & _
   	               "                     <FONT SIZE=""2""><I>" & varLink & "</I></FONT><BR>&nbsp;</TD>" & vbNewLine & _
	               "</TR>"
  
	objRecordSet.MoveNext
	varRecordNum = varRecordNum + 1

  Loop Until objRecordSet.EOF Or varRecordNum > varTotalRecords

  If objQuery.QueryTimedOut Then 
    Response.write "<TR><TD COLSPAN=""3""><B>" & cTimeoutMsg & "</b></TD></TR>"
  End if 

  '****************************************************************************
  '* J. Hales
  '* If the recordset MoreRows is true then there are more results to show
  '* so we can set the next recordnum to start from
  '* Don't forget that at this stage the RecordCoutn will be +1 more than the
  '* real value
  '*
  '* The StartHit property sets the starting result number
  '*
  '* The NextStartHit property returns the starting values for successive 
  '* pages of search results
  '* NOTE: You cannot accurately get the true value of NExtStartHit until
  '* you've interated past all records in the current record set.
  '* Unless you move to the end first using the MoveLast or MoveNext while not EOF
  '* you have to give a summary at the end
  '****************************************************************************
  If objRecordSet.Properties("MoreRows") And varRecordNum -1 < varTotalRecords Then
    objQuery.StartHit = objRecordSet.Properties("NextStartHit")

    ' Repeat query with new start hit. The query must include any 
    ' custom variables you've used: in this case, varSearchText and varRecordNum.
    Response.Write "<TR><TD COLSPAN=""3"" ALIGN=""center""><a HREF=""sitesearch.asp?" & _
                   objQuery.QueryToURL & _
                   "&DisplayText=" & Server.URLEncode(varSearchText) & _
                   "&RecordNum=" & varRecordNum & _
                   """>" & cMoreResultsLinkText & "</a>" & vbNewLine & _
                   "</TD></TR>"
  End If 

  '****************************************************************************
  '* J. Hales
  '* Close the results table
  '****************************************************************************
  Response.Write "</table><!-- END OF RESULTS TABLE --><BR>" & vbNewLine

End Sub
         
%>
<html>
<head>
  <Title>Site Search</Title>
</head>
<body leftmargin="0" topmargin="0" marginheight="0" marginwidth="0">

	<table border="0" width="600" cellpadding="0" cellspacing="0">
		<tr>
			<td valign="top">
				<form method="post" action="sitesearch.asp" name="frmSearch">
					<table border="0" cellpadding="0" cellspacing="0">
						<tr>
							<td valign="top" align="left">Enter your search word(s) or
								phrase:<br>
								<input name="txtCriteria" size="43" ><input type="submit" value="Search" name="Search"><br>
								&nbsp;&nbsp;
							</td>
						</tr>
					</table>
				</form>			
			</td>
		</tr>
		<tr>
			<td align="left" valign="top">         
  				<!--
				****************************************************************
				* J. Hales
				* This is where the actual search results go
				****************************************************************
				-->
				<%
					Call FormatSearchResults()
				%>
				<!-- ** End of search results ** -->
			</td>
		</tr>
	</table>
</body>
</html>



